Panda3D

Classes | Public Member Functions | Static Public Member Functions | List of all members
AnimPreloadTable Class Reference

This table records data about a list of animations for a particular model, such as number of frames and frame rate. More...

`#include "animPreloadTable.h"`

Inheritance diagram for AnimPreloadTable:

## Classes
class | AnimRecord

## Public Member Functions
void | add_anim (const std::string &basename, PN_stdfloat base_frame_rate, int num_frames)
| Adds a new animation record to the table. More...
void | add_anims_from (const AnimPreloadTable *other)
| Copies the animation records from the other table into this one. More...
void | clear_anims ()
| Removes all animation records from the table. More...
int | find_anim (const std::string &basename) const
| Returns the index number in the table of the animation record with the indicated name, or -1 if the name is not present. More...
virtual TypeHandle | force_init_type ()
PN_stdfloat | get_base_frame_rate (int n) const
| Returns the frame rate stored for the nth animation record. More...
std::string | get_basename (int n) const
| Returns the basename stored for the nth animation record. More...
int | get_num_anims () const
| Returns the number of animation records in the table. More...
int | get_num_frames (int n) const
| Returns the number of frames stored for the nth animation record. More...
virtual TypeHandle | get_type () const
virtual void | output (std::ostream &out) const
void | remove_anim (int n)
| Removes the nth animation records from the table. More...
virtual void | write (std::ostream &out, int indent_level) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Function to write the important information in the particular object to a Datagram. More...
Public Member Functions inherited from CopyOnWriteObject
| CopyOnWriteObject (const CopyOnWriteObject &copy)
void | operator= (const CopyOnWriteObject &copy)
Public Member Functions inherited from CachedTypedWritableReferenceCount
void | cache_ref () const
| Explicitly increments the cache reference count and the normal reference count simultaneously. More...
void | cache_ref_only () const
| Decrements the cache reference count without affecting the normal reference count. More...
bool | cache_unref () const
| Explicitly decrements the cache reference count and the normal reference count simultaneously. More...
int | get_cache_ref_count () const
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin(). More...
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static TypedWritable * | make_from_bam (const FactoryParams &params)
| Factory method to generate an AnimPreloadTable object. More...
static void | register_with_read_factory ()
| Factory method to generate an AnimPreloadTable object. More...
Static Public Member Functions inherited from CopyOnWriteObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from CachedTypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from CachedTypedWritableReferenceCount
| get_cache_ref_count
| Returns the current reference count. More...
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This table records data about a list of animations for a particular model, such as number of frames and frame rate.

It's used for implementating asynchronous binding.

This table is normally built by an offline tool, such as egg-optchar.

Definition at line 35 of file animPreloadTable.h.

## Member Function Documentation

## ◆ add_anim()

void AnimPreloadTable::add_anim | ( | const std::string & | basename,
|  | PN_stdfloat | base_frame_rate,
|  | int | num_frames
| ) |  |

Adds a new animation record to the table.

If there is already a record of this name, no operation is performed (the original record is unchanged). See find_anim(). This will invalidate existing index numbers.

Definition at line 98 of file animPreloadTable.cxx.

## ◆ add_anims_from()

void AnimPreloadTable::add_anims_from | ( | const AnimPreloadTable * | other | ) |

Copies the animation records from the other table into this one.

If a given record name exists in both tables, the record in this one supercedes.

Definition at line 113 of file animPreloadTable.cxx.

References ordered_vector< Key, Compare, Vector >::begin(), ordered_vector< Key, Compare, Vector >::end(), ordered_vector< Key, Compare, Vector >::push_back(), ordered_vector< Key, Compare, Vector >::reserve(), and ordered_vector< Key, Compare, Vector >::size().

## ◆ clear_anims()

void AnimPreloadTable::clear_anims | ( |  | ) |

Removes all animation records from the table.

Definition at line 77 of file animPreloadTable.cxx.

References ordered_vector< Key, Compare, Vector >::clear().

## ◆ find_anim()

int AnimPreloadTable::find_anim | ( | const std::string & | basename | ) | const

Returns the index number in the table of the animation record with the indicated name, or -1 if the name is not present.

By convention, the basename is the filename of the egg or bam file, without the directory part and without the extension. That is, it is Filename::get_basename_wo_extension().

Definition at line 62 of file animPreloadTable.cxx.

## ◆ get_base_frame_rate()

PN_stdfloat AnimPreloadTable::get_base_frame_rate | ( | int | n | ) | const
| inline

Returns the frame rate stored for the nth animation record.

Definition at line 42 of file animPreloadTable.I.

## ◆ get_basename()

std::string AnimPreloadTable::get_basename | ( | int | n | ) | const
| inline

Returns the basename stored for the nth animation record.

See find_anim().

Definition at line 32 of file animPreloadTable.I.

## ◆ get_num_anims()

int AnimPreloadTable::get_num_anims | ( |  | ) | const

Returns the number of animation records in the table.

Definition at line 50 of file animPreloadTable.cxx.

References ordered_vector< Key, Compare, Vector >::size().

## ◆ get_num_frames()

int AnimPreloadTable::get_num_frames | ( | int | n | ) | const
| inline

Returns the number of frames stored for the nth animation record.

Definition at line 52 of file animPreloadTable.I.

## ◆ make_from_bam()

TypedWritable * AnimPreloadTable::make_from_bam | ( | const FactoryParams & | params | ) |
| static

Factory method to generate an AnimPreloadTable object.

Definition at line 178 of file animPreloadTable.cxx.

References parse_params().

Referenced by register_with_read_factory().

## ◆ register_with_read_factory()

void AnimPreloadTable::register_with_read_factory | ( |  | ) |
| static

Factory method to generate an AnimPreloadTable object.

Definition at line 152 of file animPreloadTable.cxx.

References BamReader::get_factory(), make_from_bam(), and Factory< Type >::register_factory().

## ◆ remove_anim()

void AnimPreloadTable::remove_anim | ( | int | n | ) |

Removes the nth animation records from the table.

This renumbers indexes for following animations.

Definition at line 87 of file animPreloadTable.cxx.

## ◆ write_datagram()

void AnimPreloadTable::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg
| ) |  |
| virtual

Function to write the important information in the particular object to a Datagram.

Reimplemented from TypedWritable.

Definition at line 161 of file animPreloadTable.cxx.

References Datagram::add_uint16(), ordered_vector< Key, Compare, Vector >::begin(), ordered_vector< Key, Compare, Vector >::end(), and ordered_vector< Key, Compare, Vector >::size().

The documentation for this class was generated from the following files:

- panda/src/chan/animPreloadTable.h
- panda/src/chan/animPreloadTable.cxx
- panda/src/chan/animPreloadTable.I